<?php

$ip   = "127.0.0.1"; // IP-Adresse eures Synology-NAS
$port = "5000"; // default Port der Surveillance Station
                    
// **********************************************************************************
// Anmelden an der Surveillance Station und sid zurückgeben
// **********************************************************************************
function getSid($user, $pass, $ip, $port) {
	$link_login = 'http://' . $ip . ':' . $port . '/webapi/auth.cgi?api=SYNO.API.Auth&method=Login&version=3&account=' . $user . '&passwd=' . $pass . '&session=SurveillanceStation&format=sid';
	
	// Eventuell müsst ihr die URLs von HTTP auf HTTPS anpassen, sofern ihr HTTPS aktiviert habt!
	// Authentifizierung an Synology Surveillance Station WebAPI und auslesen der SID
	$json = file_get_contents ( $link_login );
	$obj = json_decode ( $json, true );
	@$sid = $obj ["data"] ["sid"];
	return $sid;
}

// **********************************************************************************
// Link für MJPEG von Surveillance Station lesen
// **********************************************************************************
function getStreamLink($user, $pass, $ip, $port, $cameraID) {
	$sid = getSid ( $user, $pass, $ip, $port );
	$link_stream = 'http://' . $ip . ':' . $port . '/webapi/SurveillanceStation/videoStreaming.cgi?api=SYNO.SurveillanceStation.VideoStream&version=1&method=Stream&cameraId=' . $cameraID . '&format=mjpeg&_sid=' . $sid;
	
	return $link_stream;
}

// **********************************************************************************
// Link für JPEG von Surveillance Station lesen
// **********************************************************************************
function getImageLink($user, $pass, $ip, $port, $cameraID) {
	$sid = getSid ( $user, $pass, $ip, $port );
	$link_image = 'http://' . $ip . ':' . $port . '/webapi/entry.cgi?camStm=1&version=1&cameraId=' . $cameraID . '&api="SYNO.SurveillanceStation.Camera"&preview=true&method=GetSnapshot&_sid=' . $sid;

	return $link_image;
}

// **********************************************************************************
// MJPEG Stream von Surveillance Station ausgeben
// **********************************************************************************
function printStream($user, $pass, $ip, $port, $cameraID) {
	$link_stream = getStreamLink ( $user, $pass, $ip, $port, $cameraID );
	
	set_time_limit ( 60 );
	
	$r = "";
	$i = 0;
	$boundary = "\n--myboundary";
	$new_boundary = "newboundary";
	
	$f = fopen ( $link_stream, "r" );
	
	if (! $f) {
		// **** cannot open
		print "error";
	} else {
		// **** URL OK
		header ( "Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0" );
		header ( "Cache-Control: private" );
		header ( "Pragma: no-cache" );
		header ( "Expires: -1" );
		header ( "Content-type: multipart/x-mixed-replace;boundary={$new_boundary}" );
		
		while ( true ) {
			
			while ( substr_count ( $r, "Content-Length:" ) != 2 ) {
				$r .= fread ( $f, 32 );
			}
			
			$pattern = "/Content-Length\:\s([0-9]+)\s\n(.+)/i";
			preg_match ( $pattern, $r, $matches, PREG_OFFSET_CAPTURE );
			$start = $matches [2] [1];
			$len = $matches [1] [0];
			$end = strpos ( $r, $boundary, $start ) - 1;
			$frame = substr ( "$r", $start + 2, $len );
			
			print "--{$new_boundary}\n";
			print "Content-type: image/jpeg\n";
			print "Content-Length: ${len}\n\n";
			print $frame;
			usleep ( 40 * 1000 );
			$r = substr ( "$r", $start + 2 + $len );
		}
	}
	
	fclose ( $f );
}

// **********************************************************************************
// JPEG Image von Surveillance Station ausgeben
// **********************************************************************************
function printImage($user, $pass, $ip, $port, $cameraID) {
	$link_image = getImageLink ( $user, $pass, $ip, $port, $cameraID );
	$image = file_get_contents ( $link_image );
	
	header ( "Cache-Control: no-store, no-cache, must-revalidate, pre-check=0, post-check=0, max-age=0" );
	header ( "Cache-Control: private" );
	header ( "Pragma: no-cache" );
	header ( "Expires: -1" );
	header ( "Content-type: image/jpeg" );
	header ( "Content-Length: " . ( string ) (filesize ( $image )) );
	print $image;
}

// **********************************************************************************
// Stream als MJPEG ausgeben
// http://nas-stueben.goip.de/webcam.php?usr=<benutzername>&pwd=<passwort>&cam=<1|2|...>&format=<mjpeg|jpeg>
// **********************************************************************************
$user     = $_GET ["usr"]; // Synology Benutzer mit Berechtigung die Kamera anzuzeigen
$pass     = $_GET ["pwd"]; // Passwort zu eben eingegebenem Benutzer
$cameraID = $_GET ["cam"]; // ID der Kamera, welche angezeigt werden soll
$format   = $_GET ["format"]; // format = jpeg für Image oder mjpeg für Stream

if (strtolower ( $format ) == "jpeg") {
	
	printImage ( $user, $pass, $ip, $port, $cameraID );
} else {
	
	printStream ( $user, $pass, $ip, $port, $cameraID );
}

?>

